/*
3D Starfield Simulation in 640x480x256 mode.
*/

#include <stdlib.h>
#include <conio.h>
#include <time.h>

#include "VBESDKGL.cpp"

#define STARS 300
#define DEPTH 1000
#define SCALE 4
#define WIDTH 30000



unsigned char far *vbuffer = (unsigned char far *) 0xa0000000L;
unsigned int newmode, oldmode;



int main(void) {
   void putpixel(unsigned int _xcor, unsigned int _ycor, unsigned char _color);

   unsigned int i0;
   long int starx[STARS], stary[STARS], starz[STARS];
   int oldstarx[STARS], oldstary[STARS];

   randomize();
   for(i0 = 0; i0 < STARS; i0++) {
      oldstarx[i0] = 0;
      oldstary[i0] = 0;
      starx[i0] = (random(WIDTH) - (WIDTH/2)) * SCALE;
      stary[i0] = (random(WIDTH) - (WIDTH/2)) * SCALE;
      starz[i0] = random(DEPTH)+1;
      }

   vbegl.getmode(&oldmode);
   newmode = vbegl.findmode(640, 480, 8); if (newmode == 0xffff) return 1;
   vbegl.setmode(newmode);

   while( !kbhit() ) {
      for(i0 = 0; i0 < STARS; i0++) {
         putpixel(oldstarx[i0], oldstary[i0], 0x00);
         starz[i0]--;
         if (starz[i0] == 0) starz[i0] = DEPTH;
         oldstarx[i0] = ((starx[i0] * SCALE) / starz[i0]) + (vbemodeinfo.xresolution()/2);
         oldstary[i0] = ((stary[i0] * SCALE) / starz[i0]) + (vbemodeinfo.yresolution()/2);
         putpixel(oldstarx[i0], oldstary[i0], 0x0f);
         }
      }

   vbegl.setmode(oldmode);
   return 0;
   }

   void putpixel(unsigned int _xcor, unsigned int _ycor, unsigned char _color) {
      unsigned long int address;

      if (_xcor < vbemodeinfo.xresolution() && _ycor < vbemodeinfo.yresolution()) {
         address = (unsigned long int)_ycor * vbemodeinfo.xresolution() + _xcor;
         vbegl.setwindowa((unsigned int)(address >> 16));
         vbuffer[address & 0xffff] = _color;
         }
      }
