/*
   Vesa Bios Extensions SDK Graphics Library (Beta)
   -----------------------------------------------------
   Ben Wright
   bwright@tcac.com

   Started 10/26/1995
*/

#include <VBESDKGL.hpp>



unsigned int VBEGL::setmode(unsigned int _mode) {
   unsigned int rcode;

   vbe.getmodeinfo(&vbemodeinfo, _mode);
   rcode = vbe.setmode(_mode);
   if (rcode == 0x004f) {
      __windowshift = 0;
      while((unsigned unsigned int)(64 >> __windowshift) != vbemodeinfo.windowgranularity()) {
         __windowshift++;
         }

      vbe.windowcontrol(0x01, 0x00, &__windowacurrent);
      vbe.windowcontrol(0x01, 0x00, &__windowbcurrent);
      }

   return rcode;
   }

unsigned int VBEGL::findmode(unsigned int _xres, unsigned int _yres, unsigned char _cdepth) {
   unsigned int i0;
   unsigned int mode;

   for(i0 = 0; ; i0++) {
      mode = vbeinfo.videomodelist(i0);
      if (mode == 0xffff) break;

      vbe.getmodeinfo(&vbemodeinfo, mode);
      if (vbemodeinfo.xresolution() == _xres && vbemodeinfo.yresolution() == _yres && vbemodeinfo.bitsperpixel() == _cdepth)
         break;
      }

   return mode;
   }
