/*
   Vesa Bios Extensions SDK Graphics Library (Beta)
   -----------------------------------------------------
   Ben Wright
   bwright@tcac.com

   Started 10/26/1995
*/

#ifndef __VBESDKGL_HPP
#define __VBESDKGL_HPP

#include "VBESDK.cpp"



VBE far vbe;
VBEInfo far vbeinfo;
VBEModeInfo far vbemodeinfo;

class VBEGL {
   private:
      unsigned char __windowshift;           // Convert to 64k Granularity
      unsigned int __windowacurrent;
      unsigned int __windowbcurrent;

   public:
      // Initialization
      VBEGL() { initialize(); }
      void initialize(void) { vbe.getinfo(&vbeinfo); }

      unsigned int setmode(unsigned int _mode);
      unsigned int getmode(unsigned int far *_mode) { return vbe.getmode(_mode); }
      unsigned int findmode(unsigned int _xres, unsigned int _yres, unsigned char _cdepth);

      // Window Control
      unsigned int setwindowa(unsigned int _window) {
         unsigned int rcode = 0x004f;

         if (_window != __windowacurrent) {
            _window <<= __windowshift;
	    rcode = vbe.windowcontrol(0x00, 0x00, &_window);
            __windowacurrent = _window;
            }

         return rcode;
	 }

      unsigned int setwindowb(unsigned int _window) {
         unsigned int rcode = 0x004f;

         if (_window != __windowbcurrent) {
            _window <<= __windowshift;
	    rcode = vbe.windowcontrol(0x00, 0x01, &_window);
            __windowbcurrent = _window;
            }

         return rcode;
	 }

      unsigned int getwindowa(unsigned int far *_window) {
	 return vbe.windowcontrol(0x01, 0x00, _window);
	 }

      unsigned int getwindowb(unsigned int far *_window) {
	 return vbe.windowcontrol(0x01, 0x01, _window);
	 }
   } far vbegl;

#endif
